package tupleexample;

import tuplespaces.*;

public class TupleExample {
    public static void main(String[] args) {
	TupleSpace t=new LocalTupleSpace();

	String[] b=new String[] {"Hello", "World"};
	t.put(b);
	b[1]="Warld";
	t.put(b);
	b[1]="Wurld";
	t.put(b);
	t.put(new String[] {"10", "true"});
	t.put(new String[] {"5", "true"});
	t.put(new String[] {"17", "false"});
	String[] a=new String[] {"Hello", "World", "Again"};
	t.put(a);
	t.put(new String[] {"Hello", "World"});
	t.put(new String[] {"pik"});
	String[] w=t.get(new String[] {null, "World"});
	assertEquals("Matching test tuple length", 
		     2, w.length);
	assertEquals("Matching test tuple[0]", "Hello", w[0]);
	assertEquals("Matching test tuple[1]", "World", w[1]);

	assertEquals("Got unexpected length tuple", 
		     t.get(new String[] {"pik"}).length, 1);
	w=t.get(new String[] {null, "true"});
	String[] w2=t.get(new String[] {null, "true"});
	assertEquals("Matching test tuple length", 
		     2, w.length);
	assertEquals("Matching test tuple length", 
		     2, w2.length);
	assertEquals("Matching test tuple numbers", 15,
		     (new Integer(w[0]).intValue())+(new Integer(w2[0]).intValue()));
	System.err.println("Basic tuple API test OK.");
    }

    public static void assertEquals(String message, String foo, String bar) {
	if (!foo.equals(bar))
	    fail(message, foo, bar);	
    }

    public static void assertEquals(String message, int foo, int bar) {
	if (foo!=bar)
	    fail(message, ""+foo, ""+bar);	
    }

    public static void fail(String message, String expected, String got) {
	System.err.println("Error:");
	System.err.println("Got: "+got);
	System.err.println("Expected: "+expected);
	System.exit(1);
    }
}
